include("header.jl")

@testset "math" begin
    @test randcheck(acos,abs_lt_1)
    @test randcheck(acosd,abs_lt_1)
    @test randcheck(acosh,val_gt_1)
    @test randcheck(acot,abs_gt_0)
    @test randcheck(acotd,abs_gt_0)
    @test randcheck(acoth,abs_gt_1)
    @test randcheck(acsc,abs_gt_1)
    @test randcheck(acscd,abs_gt_1)
    @test randcheck(acsch,abs_gt_0)
    @test randcheck(asec,abs_gt_1)
    @test randcheck(asecd,abs_gt_1)
    @test randcheck(asech,val_lt_1)
    @test randcheck(asin,abs_lt_1)
    @test randcheck(asind,abs_lt_1)
    @test randcheck(asinh)
    @test randcheck(atan)
    @test randcheck(atand)
    @test randcheck(atanh,abs_lt_1)
    @test randcheck(cbrt)
    @test randcheck(clamp,identity,xargs=(-0.5,0.5))
    #@test randcheck(clamp!) # overwrites
    @test randcheck(cos)
    @test randcheck(cosc)
    @test randcheck(cosd)
    @test randcheck(cosh)
    @test randcheck(cospi)
    @test randcheck(cot)
    @test randcheck(cotd)
    @test randcheck(coth)
    @test randcheck(csc)
    @test randcheck(cscd)
    @test randcheck(csch)
    @test randcheck(deg2rad)
    @test randcheck(exp)
    @test randcheck(exp10)
    @test randcheck(exp2)
    @test randcheck(expm1)
    @test randcheck(exponent)
    #@test randcheck(frexp) # returns 2 values
    @test randcheck(hypot,identity,identity)
    @test randcheck(ldexp,identity,xargs=(rand(-5:5),))
    @test randcheck(log,val_gt_0)
    @test randcheck(log,val_gt_0,val_gt_0)
    @test randcheck(log10,val_gt_0)
    @test randcheck(log1p,val_gt_0)
    @test randcheck(log2,val_gt_0)
    @test randcheck(max,identity,identity)
    @test randcheck(min,identity,identity)
    #@test randcheck(minmax) # returns 2 values
    @test randcheck(mod2pi)
    #@test randcheck(modf)   # returns 2 values
    @test randcheck(rad2deg)
    @test randcheck(rem2pi,identity,xargs=(RoundNearest,))
    @test randcheck(sec)
    @test randcheck(secd)
    @test randcheck(sech)
    @test randcheck(significand)
    @test randcheck(sin)
    @test randcheck(sinc)
    #@test randcheck(sincos) # returns 2 values
    @test randcheck(sind)
    @test randcheck(sinh)
    @test randcheck(sinpi)
    @test randcheck(sqrt,val_gt_0)
    @test randcheck(tan)
    @test randcheck(tand)
    @test randcheck(tanh)
end

